# need
# DEVICE	e.g.STR91x-44
# RAM		0 / 1
# THUMB		0 / 1
# INTERWORK	0 / 1

 CC	= arm-elf-gcc
 LD	= arm-elf-gcc -v
 AR	= arm-elf-ar
 AS	= arm-elf-gcc
 CP	= arm-elf-objcopy
 OD	= arm-elf-objdump

MODE	=
ifeq ($(THUMB),1)
 MODE	+= -mthumb
endif
ifeq ($(INTERWORK),1)
 MODE	+= -mthumb-interwork
endif

ifeq ($(RAM),1)
 LDFILE	= STR91x-$(DEVICE).ld RAM.ld
else
 LDFILE	= STR91x-$(DEVICE).ld ROM.ld
endif

DEFS	+= -DCODE_IN_RAM=$(RAM)

# -msoft-float results in linker error, float is by software even without this
MACHINE	= -mcpu=arm966e-s -mfpu=fpa
COPTS	= -ffunction-sections -fdata-sections -funsigned-char -fno-builtin -fshort-enums
CPPOPTS	= $(COPTS) -fno-rtti -fno-exceptions -fno-unwind-tables

CFLAGS  = -I. -fno-common $(MODE) $(MACHINE) $(DEFS) $(COPTS) $(OPTIM) $(DEBUG)
CPPFLAGS= -I. -fno-common $(MODE) $(MACHINE) $(DEFS) $(CPPOPTS) $(OPTIM) $(DEBUG)
AFLAGS  = -Wa,-ahls -Wa,-mapcs-32 $(MODE) $(MACHINE) $(DEFS) $(DEBUG)
LDFLAGS = $(MACHINE) -nostartfiles -Wl,-Map,main.map,--cref -Wl,-T$(LDFILE) $(MODE) $(MACHINE)
ODFLAGS	= -x --syms

LDLIBS	= -lgcc

%.o: %.S
	$(CC) $(AFLAGS) $< -c -o $@ > $*.lst

%.o: %.c
	$(CC) -std=gnu99 $(CFLAGS) -c $< -o $@
	
%.o: %.cc
	$(CC) $(CPPFLAGS) -c $< -o $@
	
%.o: %.cpp
	$(CC) $(CPPFLAGS) -c $< -o $@
	

