#ifndef __STR91x_H__
#define __STR91x_H__

#ifdef __cplusplus
  extern "C" void __sys_init(void);	// called by startup, prior to construction calls
  extern "C" void __scu_init(void);	// initalize SCU clocks and PLL (System.c)
  extern "C" void __flash_init(void);	// initialize flash parameters (System.c)
#else
  extern void __sys_init(void);
  extern void __scu_init(void);
  extern void __flash_init(void);
#endif

//-----------------------------------------------------------------------------
// SCU - System Control Unit

#include "str91x-scu.h"

#define SCU		(*(volatile SCU_t *)0x5C002000)

//-----------------------------------------------------------------------------
// FMI - Flash Memory Interface

#include "str91x-fmi.h"

#define FMI		(*(volatile FMI_t *)0x54000000)

//-----------------------------------------------------------------------------
// GPIO - General Purpose I/O Pins

#include "pl061-gpio.h"

#define GPIO(n)		(*(volatile GPIO_t *)(0x48006000+(n)*0x1000))
#define GPIOb(n)	(*(volatile GPIO_t *)(0x58006000+(n)*0x1000))

#define GPIO0		GPIO(0)
#define GPIO1		GPIO(1)
#define GPIO2		GPIO(2)
#define GPIO3		GPIO(3)
#define GPIO4		GPIO(4)
#define GPIO5		GPIO(5)
#define GPIO6		GPIO(6)
#define GPIO7		GPIO(7)
#define GPIO8		GPIO(8)
#define GPIO9		GPIO(9)

#define GPIODIR(n)	GPIO(n).dir
#define GPIODATA(n,m)	GPIO(n).data[(m)<<2]

//-----------------------------------------------------------------------------
// UART

#include "pl011-uart.h"

#define UART(n)		(*(volatile UART_t *)(0x5C004000+(n)*0x1000))
#define UARTb(n)	(*(volatile UART_t *)(0x4C004000+(n)*0x1000))

#define UART0		UART(0)
#define UART1		UART(1)
#define UART2		UART(2)
#define UART_COUNT	3

//-----------------------------------------------------------------------------
// Timers

#include "str91x-timer.h"

#define TIM(n)		(*(volatile TIM_t *)(0x58002000+(n)*0x1000))
#define TIMb(n)		(*(volatile TIM_t *)(0x48002000+(n)*0x1000))

#define TIM0		TIM(0)
#define TIM1		TIM(1)
#define TIM2		TIM(2)
#define TIM3		TIM(3)
#define TIM_COUNT	4

//-----------------------------------------------------------------------------
#endif //__STR91x_H__
